/********************************************************************
 *  gfont.cpp : Class to provide a global default font to views and
 *	dialogs.
 ********************************************************************/

#include <stdafx.h>
#include <gfont.h>

// Space for the class globals
CFont * CGlobalFont::m_pFont = NULL;
unsigned short CGlobalFont::m_InstanceCount = 0;
 
/////////////////////////////////////////////////////////////////////////////
CGlobalFont::CGlobalFont()
{
	if(m_InstanceCount == 0 && m_pFont == NULL) {
		CreateFont();
	}
	m_InstanceCount++;
}

/////////////////////////////////////////////////////////////////////////////
CGlobalFont::~CGlobalFont()
{
	if(--m_InstanceCount < 1 && m_pFont != NULL) {
		m_InstanceCount = 0;
		delete m_pFont;
		m_pFont = NULL;
	}
}

/////////////////////////////////////////////////////////////////////////////
void CGlobalFont::CreateFont()
{
    ASSERT(m_pFont == NULL);


    CWindowDC dc(CWnd::GetDesktopWindow());
    int nEscapement = 0;
    LOGFONT lf;
    memset(&lf, 0, sizeof(LOGFONT));

    lf.lfHeight = -MulDiv(8, dc.GetDeviceCaps(LOGPIXELSY), 72);
    lf.lfCharSet = ANSI_CHARSET;
    lf.lfQuality = DEFAULT_QUALITY;
    lf.lfClipPrecision = CLIP_LH_ANGLES | CLIP_STROKE_PRECIS;
    strcpy(lf.lfFaceName, "MS Sans Serif"); //Arial");

    lf.lfPitchAndFamily = FF_SWISS ;
    lf.lfWeight = FW_NORMAL;

    m_pFont = new CFont;
    ASSERT(m_pFont != NULL);
    if(m_pFont != NULL)
    	m_pFont->CreateFontIndirect(&lf);
}

/////////////////////////////////////////////////////////////////////////////
// The pointer returned may be temporary and should not be
// stored for later use.
CFont * CGlobalFont::GetFont()
{
	ASSERT(m_InstanceCount > 0);
	ASSERT(m_pFont != NULL);
	return(m_pFont);
}
	
/**/
